Index: sasmodels/kernelpy.py
===================================================================
--- sasmodels/kernelpy.py	(revision 3199b177cb91c6bd74017b7f942ddbbbc9bb46c0)
+++ sasmodels/kernelpy.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -16,5 +16,7 @@
     from numpy import cbrt
 except ImportError:
-    def cbrt(x): return x ** (1.0/3.0)
+    def cbrt(x):
+        """Return cubed root of x."""
+        return x ** (1.0/3.0)
 
 from .generate import F64
@@ -43,7 +45,8 @@
         self.info = model_info
         self.dtype = np.dtype('d')
-        logger.info("make python model " + self.info.name)
+        logger.info("make python model %s", self.info.name)
 
     def make_kernel(self, q_vectors):
+        """Instantiate the python kernel with input *q_vectors*"""
         q_input = PyInput(q_vectors, dtype=F64)
         return PyKernel(self.info, q_input)
Index: sasmodels/list_pars.py
===================================================================
--- sasmodels/list_pars.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/list_pars.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -16,5 +16,5 @@
 from .compare import columnize
 
-def find_pars(type=None):
+def find_pars(kind=None):
     """
     Find all parameters in all models.
@@ -26,10 +26,10 @@
         model_info = load_model_info(name)
         for p in model_info.parameters.kernel_parameters:
-            if type is None or p.type == type:
+            if kind is None or p.type == kind:
                 partable.setdefault(p.name, [])
                 partable[p.name].append(name)
     return partable
 
-def list_pars(names_only=True, type=None):
+def list_pars(names_only=True, kind=None):
     """
     Print all parameters in all models.
@@ -38,5 +38,5 @@
     occurs in.
     """
-    partable = find_pars(type)
+    partable = find_pars(kind)
     if names_only:
         print(columnize(list(sorted(partable.keys()))))
@@ -57,12 +57,12 @@
         help="list models which use this argument")
     parser.add_argument(
-        'type', default="any", nargs='?',
+        'kind', default="any", nargs='?',
         metavar="volume|orientation|sld|none|any",
         choices=['volume', 'orientation', 'sld', None, 'any'],
-        type=lambda v: None if v == 'any' else '' if v == 'none' else v,
-        help="only list arguments of the given type")
+        type=lambda v: None if v == 'any' else None if v == 'none' else v,
+        help="only list arguments of the given kind")
     args = parser.parse_args()
 
-    list_pars(names_only=not args.verbose, type=args.type)
+    list_pars(names_only=not args.verbose, kind=args.kind)
 
 if __name__ == "__main__":
Index: sasmodels/mixture.py
===================================================================
--- sasmodels/mixture.py	(revision b171acdab344b2827f9bdca29d66411c2484991f)
+++ sasmodels/mixture.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -120,4 +120,5 @@
 
     def random():
+        """Random set of model parameters for mixture model"""
         combined_pars = {}
         for k, part in enumerate(parts):
@@ -149,4 +150,7 @@
 
 class MixtureModel(KernelModel):
+    """
+    Model definition for mixture of models.
+    """
     def __init__(self, model_info, parts):
         # type: (ModelInfo, List[KernelModel]) -> None
@@ -165,15 +169,18 @@
         kernels = [part.make_kernel(q_vectors) for part in self.parts]
         return MixtureKernel(self.info, kernels)
+    make_kernel.__doc__ = KernelModel.make_kernel.__doc__
 
     def release(self):
         # type: () -> None
-        """
-        Free resources associated with the model.
-        """
+        """Free resources associated with the model."""
         for part in self.parts:
             part.release()
+    release.__doc__ = KernelModel.release.__doc__
 
 
 class MixtureKernel(Kernel):
+    """
+    Instantiated kernel for mixture of models.
+    """
     def __init__(self, model_info, kernels):
         # type: (ModelInfo, List[Kernel]) -> None
@@ -185,5 +192,5 @@
         self.results = []  # type: List[np.ndarray]
 
-    def __call__(self, call_details, values, cutoff, magnetic):
+    def Iq(self, call_details, values, cutoff, magnetic):
         # type: (CallDetails, np.ndarray, np.ndarry, float, bool) -> np.ndarray
         scale, background = values[0:2]
@@ -191,5 +198,5 @@
         # remember the parts for plotting later
         self.results = []  # type: List[np.ndarray]
-        parts = MixtureParts(self.info, self.kernels, call_details, values)
+        parts = _MixtureParts(self.info, self.kernels, call_details, values)
         for kernel, kernel_details, kernel_values in parts:
             #print("calling kernel", kernel.info.name)
@@ -208,11 +215,21 @@
         return scale*total + background
 
+    Iq.__doc__ = Kernel.Iq.__doc__
+    __call__ = Iq
+
     def release(self):
         # type: () -> None
+        """Free resources associated with the kernel."""
         for k in self.kernels:
             k.release()
 
 
-class MixtureParts(object):
+# Note: _MixtureParts doesn't implement iteration correctly, and only allows
+# a single iterator to be active at once.  It doesn't matter in this case
+# since _MixtureParts is only used in one place, but it is not clean style.
+class _MixtureParts(object):
+    """
+    Mixture component iterator.
+    """
     def __init__(self, model_info, kernels, call_details, values):
         # type: (ModelInfo, List[Kernel], CallDetails, np.ndarray) -> None
@@ -223,4 +240,9 @@
         self.values = values
         self.spin_index = model_info.parameters.npars + 2
+        # The following are redefined by __iter__, but set them here so that
+        # lint complains a little less.
+        self.part_num = -1
+        self.par_index = -1
+        self.mag_index = -1
         #call_details.show(values)
 
Index: sasmodels/model_test.py
===================================================================
--- sasmodels/model_test.py	(revision d92182f88244a4ce39a4ef855ac8295e073ff65f)
+++ sasmodels/model_test.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -61,5 +61,4 @@
 import numpy as np  # type: ignore
 
-from . import core
 from .core import list_models, load_model_info, build_model
 from .direct_model import call_kernel, call_Fq
@@ -137,8 +136,8 @@
         test_method_name = "test_%s_python" % model_info.id
         test = ModelTestCase(test_name, model_info,
-                                test_method_name,
-                                platform="dll",  # so that
-                                dtype="double",
-                                stash=stash)
+                             test_method_name,
+                             platform="dll",  # so that
+                             dtype="double",
+                             stash=stash)
         suite.addTest(test)
     else:   # kernel implemented in C
@@ -149,8 +148,8 @@
             test_method_name = "test_%s_dll" % model_info.id
             test = ModelTestCase(test_name, model_info,
-                                    test_method_name,
-                                    platform="dll",
-                                    dtype="double",
-                                    stash=stash)
+                                 test_method_name,
+                                 platform="dll",
+                                 dtype="double",
+                                 stash=stash)
             suite.addTest(test)
 
@@ -164,7 +163,7 @@
             # presence of *single=False* in the model file.
             test = ModelTestCase(test_name, model_info,
-                                    test_method_name,
-                                    platform="ocl", dtype=None,
-                                    stash=stash)
+                                 test_method_name,
+                                 platform="ocl", dtype=None,
+                                 stash=stash)
             #print("defining", test_name)
             suite.addTest(test)
@@ -179,7 +178,7 @@
             # presence of *single=False* in the model file.
             test = ModelTestCase(test_name, model_info,
-                                    test_method_name,
-                                    platform="cuda", dtype=None,
-                                    stash=stash)
+                                 test_method_name,
+                                 platform="cuda", dtype=None,
+                                 stash=stash)
             #print("defining", test_name)
             suite.addTest(test)
@@ -413,4 +412,12 @@
 # CRUFT: old interface; should be deprecated and removed
 def run_one(model_name):
+    # type: (str) -> str
+    """
+    [Deprecated] Run the tests associated with *model_name*.
+
+    Use the following instead::
+
+        succss, output = check_model(load_model_info(model_name))
+    """
     # msg = "use check_model(model_info) rather than run_one(model_name)"
     # warnings.warn(msg, category=DeprecationWarning, stacklevel=2)
@@ -421,9 +428,9 @@
         return output
 
-    success, output = check_model(model_info)
+    _, output = check_model(model_info)
     return output
 
 def check_model(model_info):
-    # type: (ModelInfo) -> str
+    # type: (ModelInfo) -> Tuple[bool, str]
     """
     Run the tests for a single model, capturing the output.
@@ -492,5 +499,5 @@
         loaders.append('cuda')
     tests = make_suite(loaders, ['all'])
-    def build_test(test):
+    def _build_test(test):
         # In order for nosetest to show the test name, wrap the test.run_all
         # instance in function that takes the test name as a parameter which
@@ -510,5 +517,5 @@
 
     for test in tests:
-        yield build_test(test)
+        yield _build_test(test)
 
 
@@ -539,19 +546,19 @@
                         "models will be tested.  See core.list_models() for "
                         "names of other groups, such as 'py' or 'single'.")
-    args, models = parser.parse_known_args()
-
-    if args.engine == "opencl":
+    opts = parser.parse_args()
+
+    if opts.engine == "opencl":
         if not use_opencl():
             print("opencl is not available")
             return 1
         loaders = ['opencl']
-    elif args.engine == "dll":
+    elif opts.engine == "dll":
         loaders = ["dll"]
-    elif args.engine == "cuda":
+    elif opts.engine == "cuda":
         if not use_cuda():
             print("cuda is not available")
             return 1
         loaders = ['cuda']
-    elif args.engine == "all":
+    elif opts.engine == "all":
         loaders = ['dll']
         if use_opencl():
@@ -560,9 +567,9 @@
             loaders.append('cuda')
     else:
-        print("unknown engine " + args.engine)
+        print("unknown engine " + opts.engine)
         return 1
 
-    runner = TestRunner(verbosity=args.verbose, **test_args)
-    result = runner.run(make_suite(loaders, args.models))
+    runner = TestRunner(verbosity=opts.verbose, **test_args)
+    result = runner.run(make_suite(loaders, opts.models))
     return 1 if result.failures or result.errors else 0
 
Index: sasmodels/modelinfo.py
===================================================================
--- sasmodels/modelinfo.py	(revision d8eaa3df1322c45c7c27c76e3029929844afb9b9)
+++ sasmodels/modelinfo.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -1004,11 +1004,13 @@
     #: *have_Fq* is True, then Iq should return an interleaved array of
     #: $[\sum F(q_1), \sum F^2(q_1), \ldots, \sum F(q_n), \sum F^2(q_n)]$.
-    Iq = None               # type: Union[None, str, Callable[[np.ndarray], np.ndarray]]
+    Iq = None               # type: Union[None, str, Callable[[...], np.ndarray]]
+    #: Returns *I(qx, qy, a, b, ...)*.  The interface follows :attr:`Iq`.
+    Iqxy = None             # type: Union[None, str, Callable[[...], np.ndarray]]
     #: Returns *I(qab, qc, a, b, ...)*.  The interface follows :attr:`Iq`.
-    Iqac = None             # type: Union[None, str, Callable[[np.ndarray], np.ndarray]]
+    Iqac = None             # type: Union[None, str, Callable[[...], np.ndarray]]
     #: Returns *I(qa, qb, qc, a, b, ...)*.  The interface follows :attr:`Iq`.
-    Iqabc = None            # type: Union[None, str, Callable[[np.ndarray], np.ndarray]]
+    Iqabc = None            # type: Union[None, str, Callable[[...], np.ndarray]]
     #: Returns *I(qx, qy, a, b, ...)*.  The interface follows :attr:`Iq`.
-    Imagnetic = None        # type: Union[None, str, Callable[[np.ndarray], np.ndarray]]
+    Imagnetic = None        # type: Union[None, str, Callable[[...], np.ndarray]]
     #: Returns a model profile curve *x, y*.  If *profile* is defined, this
     #: curve will appear in response to the *Show* button in SasView.  Use
Index: sasmodels/models/_spherepy.py
===================================================================
--- sasmodels/models/_spherepy.py	(revision 304c775207a9dbbadb23ad414848454d66b556d1)
+++ sasmodels/models/_spherepy.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -69,10 +69,13 @@
 
 def form_volume(radius):
+    """Calculate volume for sphere"""
     return 1.333333333333333 * pi * radius ** 3
 
 def effective_radius(mode, radius):
+    """Calculate R_eff for sphere"""
     return radius
 
 def Iq(q, sld, sld_solvent, radius):
+    """Calculate I(q) for sphere"""
     #print "q",q
     #print "sld,r",sld,sld_solvent,radius
Index: sasmodels/models/adsorbed_layer.py
===================================================================
--- sasmodels/models/adsorbed_layer.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/models/adsorbed_layer.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -87,4 +87,5 @@
 def Iq(q, second_moment, adsorbed_amount, density_shell, radius,
        volfraction, sld_shell, sld_solvent):
+    """Return I(q) for adsorbed layer model."""
     with errstate(divide='ignore'):
         aa = ((sld_shell - sld_solvent)/density_shell * adsorbed_amount) / q
@@ -96,4 +97,5 @@
 
 def random():
+    """Return a random parameter set for the model."""
     # only care about the value of second_moment:
     #    curve = scale * e**(-second_moment^2 q^2)/q^2
Index: sasmodels/models/barbell.py
===================================================================
--- sasmodels/models/barbell.py	(revision 99658f6e997e12486269a52113af19f5089e0ef0)
+++ sasmodels/models/barbell.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -79,5 +79,5 @@
 .. [#] H Kaya and N R deSouza, *J. Appl. Cryst.*, 37 (2004) 508-509 (addenda
    and errata)
-L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949). 
+L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949).
 
 Authorship and Verification
@@ -117,10 +117,12 @@
 
 source = ["lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c", "barbell.c"]
-have_Fq = True 
+have_Fq = True
 effective_radius_type = [
-    "equivalent cylinder excluded volume","equivalent volume sphere", "radius", "half length", "half total length",
+    "equivalent cylinder excluded volume", "equivalent volume sphere",
+    "radius", "half length", "half total length",
     ]
 
 def random():
+    """Return a random parameter set for the model."""
     # TODO: increase volume range once problem with bell radius is fixed
     # The issue is that bell radii of more than about 200 fail at high q
Index: sasmodels/models/bcc_paracrystal.py
===================================================================
--- sasmodels/models/bcc_paracrystal.py	(revision da7b26b2f3ecdd4d6eea063846bb148e3def2477)
+++ sasmodels/models/bcc_paracrystal.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -1,6 +1,6 @@
 r"""
-.. warning:: This model and this model description are under review following 
-             concerns raised by SasView users. If you need to use this model, 
-             please email help@sasview.org for the latest situation. *The 
+.. warning:: This model and this model description are under review following
+             concerns raised by SasView users. If you need to use this model,
+             please email help@sasview.org for the latest situation. *The
              SasView Developers. September 2018.*
 
@@ -141,4 +141,5 @@
 
 def random():
+    """Return a random parameter set for the model."""
     # Define lattice spacing as a multiple of the particle radius
     # using the formulat a = 4 r/sqrt(3).  Systems which are ordered
Index: sasmodels/models/be_polyelectrolyte.py
===================================================================
--- sasmodels/models/be_polyelectrolyte.py	(revision ca77fc11c7ce03a565ec1aaf8755f560748546d0)
+++ sasmodels/models/be_polyelectrolyte.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -36,5 +36,5 @@
   constituting the polymer monomer and the solvent molecules, respectively.
 
-- $v_p$ and $v_s$ are the partial molar volume of the polymer and the 
+- $v_p$ and $v_s$ are the partial molar volume of the polymer and the
   solvent, respectively.
 
@@ -50,5 +50,5 @@
 - $C_s$ is the concentration of monovalent salt(1/|Ang^3| - internally converted from mol/L).
 
-- $\alpha$ is the degree of ionization (the ratio of charged monomers to the total 
+- $\alpha$ is the degree of ionization (the ratio of charged monomers to the total
   number of monomers)
 
@@ -74,10 +74,10 @@
 dimensionally useful units of 1/|Ang^3|, only the converted version of the
 polymer concentration was actually being used in the calculation while the
-unconverted salt concentration (still in apparent units of mol/L) was being 
-used.  This was carried through to Sasmodels as used for SasView 4.1 (though 
-the line of code converting the salt concentration to the new units was removed 
-somewhere along the line). Simple dimensional analysis of the calculation shows 
-that the converted salt concentration should be used, which the original code 
-suggests was the intention, so this has now been corrected (for SasView 4.2). 
+unconverted salt concentration (still in apparent units of mol/L) was being
+used.  This was carried through to Sasmodels as used for SasView 4.1 (though
+the line of code converting the salt concentration to the new units was removed
+somewhere along the line). Simple dimensional analysis of the calculation shows
+that the converted salt concentration should be used, which the original code
+suggests was the intention, so this has now been corrected (for SasView 4.2).
 Once better validation has been performed this note will be removed.
 
@@ -141,5 +141,5 @@
     :params: see parameter table
     :return: 1-D form factor for polyelectrolytes in low salt
-    
+
     parameter names, units, default values, and behavior (volume, sld etc) are
     defined in the parameter table.  The concentrations are converted from
@@ -167,4 +167,5 @@
 
 def random():
+    """Return a random parameter set for the model."""
     # TODO: review random be_polyelectrolyte model generation
     pars = dict(
Index: sasmodels/models/binary_hard_sphere.py
===================================================================
--- sasmodels/models/binary_hard_sphere.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/models/binary_hard_sphere.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -112,4 +112,5 @@
 
 def random():
+    """Return a random parameter set for the model."""
     # TODO: binary_hard_sphere fails at low qr
     radius_lg = 10**np.random.uniform(2, 4.7)
Index: sasmodels/models/broad_peak.py
===================================================================
--- sasmodels/models/broad_peak.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/models/broad_peak.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -96,4 +96,5 @@
 
 def random():
+    """Return a random parameter set for the model."""
     pars = dict(
         scale=1,
Index: sasmodels/models/capped_cylinder.py
===================================================================
--- sasmodels/models/capped_cylinder.py	(revision 99658f6e997e12486269a52113af19f5089e0ef0)
+++ sasmodels/models/capped_cylinder.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -82,5 +82,5 @@
 .. [#] H Kaya and N-R deSouza, *J. Appl. Cryst.*, 37 (2004) 508-509 (addenda
    and errata)
-L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949). 
+L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949).
 
 Authorship and Verification
@@ -139,8 +139,10 @@
 have_Fq = True
 effective_radius_type = [
-    "equivalent cylinder excluded volume", "equivalent volume sphere", "radius", "half length", "half total length",
+    "equivalent cylinder excluded volume", "equivalent volume sphere",
+    "radius", "half length", "half total length",
     ]
 
 def random():
+    """Return a random parameter set for the model."""
     # TODO: increase volume range once problem with bell radius is fixed
     # The issue is that bell radii of more than about 200 fail at high q
Index: sasmodels/models/core_multi_shell.py
===================================================================
--- sasmodels/models/core_multi_shell.py	(revision ee60aa768b29c58e20b19e94578ec3a94a0889d7)
+++ sasmodels/models/core_multi_shell.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -103,4 +103,5 @@
 
 def random():
+    """Return a random parameter set for the model."""
     num_shells = np.minimum(np.random.poisson(3)+1, 10)
     total_radius = 10**np.random.uniform(1.7, 4)
Index: sasmodels/models/core_shell_bicelle.py
===================================================================
--- sasmodels/models/core_shell_bicelle.py	(revision 99658f6e997e12486269a52113af19f5089e0ef0)
+++ sasmodels/models/core_shell_bicelle.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -89,6 +89,6 @@
    from Proquest <http://search.proquest.com/docview/304915826?accountid
    =26379>`_
-   
-   L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949). 
+
+   L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949).
 
 Authorship and Verification
@@ -158,9 +158,10 @@
 have_Fq = True
 effective_radius_type = [
-    "excluded volume","equivalent volume sphere", "outer rim radius",
+    "excluded volume", "equivalent volume sphere", "outer rim radius",
     "half outer thickness", "half diagonal",
     ]
 
 def random():
+    """Return a random parameter set for the model."""
     pars = dict(
         radius=10**np.random.uniform(1.3, 3),
Index: sasmodels/models/core_shell_bicelle_elliptical.py
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical.py	(revision 99658f6e997e12486269a52113af19f5089e0ef0)
+++ sasmodels/models/core_shell_bicelle_elliptical.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -100,5 +100,5 @@
 
 .. [#]
-L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949). 
+L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949).
 
 Authorship and Verification
@@ -149,9 +149,11 @@
 have_Fq = True
 effective_radius_type = [
-    "equivalent cylinder excluded volume", "equivalent volume sphere", "outer rim average radius", "outer rim min radius",
+    "equivalent cylinder excluded volume", "equivalent volume sphere",
+    "outer rim average radius", "outer rim min radius",
     "outer max radius", "half outer thickness", "half diagonal",
     ]
 
 def random():
+    """Return a random parameter set for the model."""
     outer_major = 10**np.random.uniform(1, 4.7)
     outer_minor = 10**np.random.uniform(1, 4.7)
Index: sasmodels/models/core_shell_bicelle_elliptical_belt_rough.py
===================================================================
--- sasmodels/models/core_shell_bicelle_elliptical_belt_rough.py	(revision 99658f6e997e12486269a52113af19f5089e0ef0)
+++ sasmodels/models/core_shell_bicelle_elliptical_belt_rough.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -112,5 +112,5 @@
 
 .. [#]
-L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949). 
+L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949).
 
 Authorship and Verification
@@ -162,7 +162,10 @@
 have_Fq = True
 effective_radius_type = [
-    "equivalent cylinder excluded volume", "equivalent volume sphere", "outer rim average radius", "outer rim min radius",
+    "equivalent cylinder excluded volume", "equivalent volume sphere",
+    "outer rim average radius", "outer rim min radius",
     "outer max radius", "half outer thickness", "half diagonal",
     ]
+
+# TODO: No random() for core-shell bicelle elliptical belt rough
 
 demo = dict(scale=1, background=0,
@@ -190,6 +193,7 @@
     #[{'radius': 30.0, 'x_core': 3.0, 'thick_rim':8.0, 'thick_face':14.0, 'length':50.0}, 'VR', 1],
 
-    [{'radius': 30.0, 'x_core': 3.0, 'thick_rim':8.0, 'thick_face':14.0, 'length':50.0,
-      'sld_core':4.0, 'sld_face':7.0, 'sld_rim':1.0, 'sld_solvent':6.0, 'background':0.0},
+    [{'radius': 30.0, 'x_core': 3.0, 'thick_rim': 8.0, 'thick_face': 14.0,
+      'length': 50.0, 'sld_core': 4.0, 'sld_face': 7.0, 'sld_rim': 1.0,
+      'sld_solvent': 6.0, 'background': 0.0},
      0.015, 189.328],
     #[{'theta':80., 'phi':10.}, (qx, qy), 7.88866563001 ],
Index: sasmodels/models/core_shell_cylinder.py
===================================================================
--- sasmodels/models/core_shell_cylinder.py	(revision 99658f6e997e12486269a52113af19f5089e0ef0)
+++ sasmodels/models/core_shell_cylinder.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -70,5 +70,5 @@
    1445-1452
 .. [#kline] S R Kline, *J Appl. Cryst.*, 39 (2006) 895
-L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949). 
+L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949).
 
 Authorship and Verification
@@ -139,4 +139,5 @@
 
 def random():
+    """Return a random parameter set for the model."""
     outer_radius = 10**np.random.uniform(1, 4.7)
     # Use a distribution with a preference for thin shell or thin core
Index: sasmodels/models/core_shell_ellipsoid.py
===================================================================
--- sasmodels/models/core_shell_ellipsoid.py	(revision 99658f6e997e12486269a52113af19f5089e0ef0)
+++ sasmodels/models/core_shell_ellipsoid.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -147,9 +147,10 @@
 have_Fq = True
 effective_radius_type = [
-    "average outer curvature", "equivalent volume sphere",     
+    "average outer curvature", "equivalent volume sphere",
     "min outer radius", "max outer radius",
     ]
 
 def random():
+    """Return a random parameter set for the model."""
     volume = 10**np.random.uniform(5, 12)
     outer_polar = 10**np.random.uniform(1.3, 4)
Index: sasmodels/models/core_shell_parallelepiped.py
===================================================================
--- sasmodels/models/core_shell_parallelepiped.py	(revision 99658f6e997e12486269a52113af19f5089e0ef0)
+++ sasmodels/models/core_shell_parallelepiped.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -173,5 +173,5 @@
    from Proquest <http://search.proquest.com/docview/304915826?accountid
    =26379>`_
-L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949). 
+L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949).
 
 Authorship and Verification
@@ -186,5 +186,5 @@
 
 import numpy as np
-from numpy import pi, inf, sqrt, cos, sin
+from numpy import inf
 
 name = "core_shell_parallelepiped"
@@ -229,5 +229,5 @@
 have_Fq = True
 effective_radius_type = [
-    "equivalent cylinder excluded volume", 
+    "equivalent cylinder excluded volume",
     "equivalent volume sphere",
     "half outer length_a", "half outer length_b", "half outer length_c",
@@ -237,4 +237,5 @@
 
 def random():
+    """Return a random parameter set for the model."""
     outer = 10**np.random.uniform(1, 4.7, size=3)
     thick = np.random.beta(0.5, 0.5, size=3)*(outer-2) + 1
@@ -269,5 +270,5 @@
 # 2d values not tested against other codes or models
 if 0:  # pak: model rewrite; need to update tests
-    qx, qy = 0.2 * cos(pi/6.), 0.2 * sin(pi/6.)
+    qx, qy = 0.2 * np.cos(np.pi/6.), 0.2 * np.sin(np.pi/6.)
     tests = [[{}, 0.2, 0.533149288477],
              [{}, [0.2], [0.533149288477]],
Index: sasmodels/models/core_shell_sphere.py
===================================================================
--- sasmodels/models/core_shell_sphere.py	(revision 304c775207a9dbbadb23ad414848454d66b556d1)
+++ sasmodels/models/core_shell_sphere.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -84,4 +84,5 @@
 
 def random():
+    """Return a random parameter set for the model."""
     outer_radius = 10**np.random.uniform(1.3, 4.3)
     # Use a distribution with a preference for thin shell or thin core
Index: sasmodels/models/cylinder.py
===================================================================
--- sasmodels/models/cylinder.py	(revision 99658f6e997e12486269a52113af19f5089e0ef0)
+++ sasmodels/models/cylinder.py	(revision b297ba9e837aada12de87cd46ea7a01bfe549da7)
@@ -98,5 +98,5 @@
 J. S. Pedersen, Adv. Colloid Interface Sci. 70, 171-210 (1997).
 G. Fournet, Bull. Soc. Fr. Mineral. Cristallogr. 74, 39-113 (1951).
-L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949). 
+L. Onsager, Ann. New York Acad. Sci. 51, 627-659 (1949).
 """
 
@@ -146,4 +146,5 @@
 
 def random():
+    """Return a random parameter set for the model."""
     volume = 10**np.random.uniform(5, 12)
     length = 10**np.random.uniform(-2, 2)*volume**0.333
@@ -184,16 +185,33 @@
 
 # Default radius and length
-radius, length = parameters[2][2], parameters[3][2]
+def calc_volume(radius, length):
+    """Return form volume for cylinder."""
+    return pi*radius**2*length
+def calc_r_effs(radius, length):
+    """Return effective radii for modes 0-7 of cylinder."""
+    return [
+        0.,
+        0.5*(0.75*radius*(2.0*radius*length
+                          + (radius + length)*(pi*radius + length)))**(1./3.),
+        (0.75*radius**2*length)**(1./3.),
+        radius,
+        length/2.,
+        min(radius, length/2.),
+        max(radius, length/2.),
+        np.sqrt(4*radius**2 + length**2)/2.,
+    ]
+r_effs = calc_r_effs(parameters[2][2], parameters[3][2])
+cyl_vol = calc_volume(parameters[2][2], parameters[3][2])
 tests.extend([
-    ({'radius_effective_mode': 0}, 0.1, None, None, 0., pi*radius**2*length, 1.0),   
-    ({'radius_effective_mode': 1}, 0.1, None, None, 0.5*(0.75*radius*(2.0*radius*length + (radius + length)*(pi*radius + length)))**(1./3.), None, None),    
-    ({'radius_effective_mode': 2}, 0.1, None, None, (0.75*radius**2*length)**(1./3.), None, None),
-    ({'radius_effective_mode': 3}, 0.1, None, None, radius, None, None),
-    ({'radius_effective_mode': 4}, 0.1, None, None, length/2., None, None),
-    ({'radius_effective_mode': 5}, 0.1, None, None, min(radius, length/2.), None, None),
-    ({'radius_effective_mode': 6}, 0.1, None, None, max(radius, length/2.), None, None),
-    ({'radius_effective_mode': 7}, 0.1, None, None, np.sqrt(4*radius**2 + length**2)/2., None, None),
+    ({'radius_effective_mode': 0}, 0.1, None, None, r_effs[0], cyl_vol, 1.0),
+    ({'radius_effective_mode': 1}, 0.1, None, None, r_effs[1], None, None),
+    ({'radius_effective_mode': 2}, 0.1, None, None, r_effs[2], None, None),
+    ({'radius_effective_mode': 3}, 0.1, None, None, r_effs[3], None, None),
+    ({'radius_effective_mode': 4}, 0.1, None, None, r_effs[4], None, None),
+    ({'radius_effective_mode': 5}, 0.1, None, None, r_effs[5], None, None),
+    ({'radius_effective_mode': 6}, 0.1, None, None, r_effs[6], None, None),
+    ({'radius_effective_mode': 7}, 0.1, None, None, r_effs[7], None, None),
 ])
-del radius, length
+del r_effs, cyl_vol
 # pylint: enable=bad-whitespace, line-too-long
 
